#pragma hdrstop

#include "OLEwork.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)

//---------------------------------------------------------------------------
AnsiString CheckOffice()
{
 AnsiString S="";
 TRegistry *Registry = new TRegistry;
 Registry->RootKey = HKEY_LOCAL_MACHINE;
 if (Registry->KeyExists("SOFTWARE\\Microsoft\\Office\\9.0\\Word"))
        S="MSO";
 if (Registry->KeyExists("SOFTWARE\\Microsoft\\Office\\10.0\\Word"))
        S="MSO";
 if (Registry->KeyExists("SOFTWARE\\Microsoft\\Office\\11.0\\Word"))
        S="MSO";
 if (Registry->KeyExists("SOFTWARE\\Microsoft\\Office\\12.0\\Word"))
        S="MSO";
 if (Registry->KeyExists("SOFTWARE\\OpenOffice.org\\OpenOffice.org"))
        S="OO";
 delete Registry;
 return S;
}
//---------------------------------------------------------------------------
void OfficeVisible(AnsiString Office, Variant app, Variant Document, bool Visible)
{
// 
  try
    {
     if (Office=="OO")
      {
       Variant Frame, CurrentController, ContainerWindow;
       CurrentController = Document.OleFunction("getCurrentController");
       Frame = CurrentController.OleFunction("getFrame");
       ContainerWindow = Frame.OleFunction("getContainerWindow");
       ContainerWindow.OleFunction("setVisible",Visible);
      }
     if (Office=="MSO")
      {
       app.OlePropertySet("Visible", Visible);
      }
    }
  catch (Exception &E)
    {
     ShowMessage("     " + E.Message);
    }
}
//---------------------------------------------------------------------------
void OfficeFindReplace(AnsiString Office, Variant app, Variant Document, AnsiString sFind, AnsiString sReplace)
{
//    
  try
    {
     if (Office=="OO")
      {
      /*
       //    
       Variant FindParam = Document.OleFunction("createSearchDescriptor");
       FindParam.OlePropertySet("SearchString", sFind);
       FindParam.OlePropertySet("ReplaceString", sReplace);
       Document.OleFunction("ReplaceAll", FindParam);
       */
       Variant ServiceManager;
       ServiceManager = Variant::CreateObject("com.sun.star.ServiceManager");

       Variant MyStruct3 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct3.OlePropertySet("name",        "SearchItem.StyleFamily");
       MyStruct3.OlePropertySet("value",        2);
       Variant MyStruct4 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct4.OlePropertySet("name",        "SearchItem.CellType");
       MyStruct4.OlePropertySet("value",        0);
       Variant MyStruct5 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct5.OlePropertySet("name",        "SearchItem.RowDirection");
       MyStruct5.OlePropertySet("value",        true);
       Variant MyStruct6 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct6.OlePropertySet("name",        "SearchItem.AllTables");
       MyStruct6.OlePropertySet("value",        false);
       Variant MyStruct7 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct7.OlePropertySet("name",        "SearchItem.Backward");
       MyStruct7.OlePropertySet("value",        false);
       Variant MyStruct8 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct8.OlePropertySet("name",        "SearchItem.Pattern");
       MyStruct8.OlePropertySet("value",        false);
       Variant MyStruct9 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct9.OlePropertySet("name",        "SearchItem.Content");
       MyStruct9.OlePropertySet("value",        false);
       Variant MyStruct10 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct10.OlePropertySet("name",        "SearchItem.AsianOptions");
       MyStruct10.OlePropertySet("value",        false);
       Variant MyStruct11 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct11.OlePropertySet("name",        "SearchItem.AlgorithmType");
       MyStruct11.OlePropertySet("value",        0);

       Variant MyStruct2 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct2.OlePropertySet("name",       "SearchItem.SearchFlags");
       MyStruct2.OlePropertySet("value",      65552); //  65536 -    
       Variant MyStruct = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct.OlePropertySet("name",        "SearchItem.SearchString");
       MyStruct.OlePropertySet("value",       sFind);
       Variant MyStruct1 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct1.OlePropertySet("name",       "SearchItem.ReplaceString");
       MyStruct1.OlePropertySet("value",      sReplace);

       Variant MyStruct12 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct12.OlePropertySet("name",        "SearchItem.Locale");
       MyStruct12.OlePropertySet("value",        255);
       Variant MyStruct13 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct13.OlePropertySet("name",        "SearchItem.ChangedChars");
       MyStruct13.OlePropertySet("value",        2);
       Variant MyStruct14 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct14.OlePropertySet("name",        "SearchItem.DeletedChars");
       MyStruct14.OlePropertySet("value",        2);
       Variant MyStruct15 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct15.OlePropertySet("name",        "SearchItem.InsertedChars");
       MyStruct15.OlePropertySet("value",        2);
       Variant MyStruct16 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct16.OlePropertySet("name",        "SearchItem.TransliterateFlags");
       MyStruct16.OlePropertySet("value",        1024);
       Variant MyStruct17 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct17.OlePropertySet("name",        "SearchItem.Command");
       MyStruct17.OlePropertySet("value",        3);
       Variant MyStruct18 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct18.OlePropertySet("name",        "Quiet");
       MyStruct18.OlePropertySet("value",        true);

       int Bounds[2] = {0,18}; //  18 
       Variant SearchParam = VarArrayCreate(Bounds, 1, varVariant);

       SearchParam.PutElement(MyStruct3, 3);
       SearchParam.PutElement(MyStruct4, 4);
       SearchParam.PutElement(MyStruct5, 5);
       SearchParam.PutElement(MyStruct6, 6);
       SearchParam.PutElement(MyStruct7, 7);
       SearchParam.PutElement(MyStruct8, 8);
       SearchParam.PutElement(MyStruct9, 9);
       SearchParam.PutElement(MyStruct10, 10);
       SearchParam.PutElement(MyStruct11, 11);

       SearchParam.PutElement(MyStruct, 0);
       SearchParam.PutElement(MyStruct1, 1);
       SearchParam.PutElement(MyStruct2, 2);

       SearchParam.PutElement(MyStruct12, 12);
       SearchParam.PutElement(MyStruct13, 13);
       SearchParam.PutElement(MyStruct14, 14);
       SearchParam.PutElement(MyStruct15, 15);
       SearchParam.PutElement(MyStruct16, 16);
       SearchParam.PutElement(MyStruct17, 17);
       SearchParam.PutElement(MyStruct18, 18);


       Variant Dispatcher, Frame, CurrentController;
       CurrentController = Document.OleFunction("getCurrentController");
       Frame = CurrentController.OleFunction("getFrame");
       Dispatcher= ServiceManager.OleFunction("createInstance", "com.sun.star.frame.DispatchHelper");
       Dispatcher.OleFunction("executeDispatch", Frame, ".uno:ExecuteSearch", "", 0, SearchParam);
      }
     if (Office=="MSO")
      {
        Variant this_selection, this_find;
        this_selection = app.OlePropertyGet("Selection") ;
        this_find = this_selection.OlePropertyGet("Find") ;
        //--- 
        this_find.OleProcedure ("Execute",
        /* FindText          */      sFind,
        /* MatchCase         */      false,
        /* MatchWholeWord    */      true, //  false -    
        /* MatchWildcards    */      false,
        /* MatchSoundsLike   */      false,
        /* MatchAllWordForms */      false,
        /* Forward           */      true,
        /* Wrap              */      1,
        /* Format            */      false,
        /* ReplaceWith       */      sReplace,
        /* Replace           */      2
        );
      }
    }
  catch (Exception &E)
    {
     ShowMessage("     " + E.Message);
    }
}
//---------------------------------------------------------------------------
bool UNODispatch(Variant Document, String ooCommand, Variant ooParams)
{
// Dispatcher   ooParams  
//  PrintPreview
    bool RetVal=true;
    int Bounds[2] = {0,-1};
    try{
      Variant ooDispatcher, ooFrame, CurrentController, ServiceManager;
      ServiceManager = Variant::CreateObject("com.sun.star.ServiceManager");
      if ((VarIsEmpty(ooParams)==true) || (VarIsNull(ooParams)==true))
              ooParams= VarArrayCreate(Bounds,1, varVariant);
      CurrentController = Document.OleFunction("getCurrentController");
      ooFrame = CurrentController.OleFunction("getFrame");
      ooDispatcher= ServiceManager.OleFunction("createInstance", "com.sun.star.frame.DispatchHelper");
      ooDispatcher.OleFunction("executeDispatch",ooFrame, ooCommand, "", 0, ooParams);
    }
     catch (Exception &E)
       {    RetVal=false;    }
    return RetVal;
};
//---------------------------------------------------------------------------
void OfficePrintPreview(AnsiString Office, Variant Document)
{
// UNODispatch
  try
   {
     if (Office=="OO")
      {
        int Bounds[2] = {0,-1};
        Variant vEmptyParam = VarArrayCreate(Bounds, 1, varVariant);
        UNODispatch(Document, ".uno:PrintPreview", vEmptyParam);
      }
     if (Office=="MSO")
      {
        Document.OleFunction("PrintPreview");
      }
   }
  catch (Exception &E)
  { ShowMessage("   " + E.Message);   }

}
//---------------------------------------------------------------------------
void OfficePrint(AnsiString Office, Variant app, Variant Document)
{
// 
  try
    {
     if (Office=="OO")
      {
       int EmptyBounds[2] = {0,-1};
       Document.OleFunction("print", VarArrayCreate(EmptyBounds, 1, varVariant));
      }
     if (Office=="MSO")
      {
       app.OleFunction("PrintOut");
      }
    }
  catch (Exception &E)
    {
     ShowMessage("     " + E.Message);
    }
}
//---------------------------------------------------------------------------
void OfficePrintParam(AnsiString Office, Variant app, Variant Document, int vCopies, AnsiString vRangeText, AnsiString vPrinter)
{
//  vRangeText   vCopies     vPrinter
//        
  try
    {
     if (Office=="OO")
      {
       Variant ServiceManager;
       ServiceManager = Variant::CreateObject("com.sun.star.ServiceManager");
       Variant MyStruct = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct.OlePropertySet("name",        "Copies");
       MyStruct.OlePropertySet("value",        vCopies);
       Variant MyStruct_1 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct_1.OlePropertySet("name",        "RangeText");
       MyStruct_1.OlePropertySet("value",        vRangeText); //    "1,5-7"
       Variant MyStruct_2 = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
       MyStruct_2.OlePropertySet("name",        "Collate");
       MyStruct_2.OlePropertySet("value",        false);

       int Bounds[2] = {0,2};
       Variant PrintParam = VarArrayCreate(Bounds, 1, varVariant);
       PrintParam.PutElement(MyStruct, 0);
       PrintParam.PutElement(MyStruct_1, 1);
       PrintParam.PutElement(MyStruct_2, 2);

       // 
        Variant PrintDescStruct = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
        PrintDescStruct.OlePropertySet("Name", "Name");
        PrintDescStruct.OlePropertySet("Value", vPrinter);
        int PrintDescBounds[2] = {0,0};
        Variant PrintDesc = VarArrayCreate(PrintDescBounds, 1, varVariant);
        PrintDesc.PutElement(PrintDescStruct, 0);
        Document.OleFunction("setPrinter", PrintDesc);

       Variant Dispatcher, Frame, CurrentController;
       CurrentController = Document.OleFunction("getCurrentController");
       Frame = CurrentController.OleFunction("getFrame");

       Dispatcher= ServiceManager.OleFunction("createInstance", "com.sun.star.frame.DispatchHelper");
       //      PrintParam   !
       Dispatcher.OleFunction("executeDispatch", Frame, ".uno:Print", "", 0, PrintParam);

      //   ,  
       PrintParam = Unassigned;
       PrintDesc  = Unassigned;
      }
     if (Office=="MSO")
      {
       app.OlePropertySet("ActivePrinter", vPrinter);
       OleVariant
           tr = true,
           fl=false,
           copies= vCopies,
           _Range= 4, //wdPrintRangeOfPages
           _Item=  0, //wdPrintDocumentContent
           _PageType= 0, //wdPrintAllPages
           _FileName=(AnsiString)"",
           _page=(AnsiString)vRangeText;
       app.OleFunction("PrintOut", fl, fl, _Range, _FileName, EmptyParam,
                                    EmptyParam, _Item, copies, _page, _PageType, fl,
                                    tr, EmptyParam, EmptyParam);
      }
    }
  catch (Exception &E)
    {
     ShowMessage("     " + E.Message);
    }
}
//---------------------------------------------------------------------------
void OfficeFillCell(AnsiString Office, Variant Document,int table,int string,int row, AnsiString str)
{
//   STR    (String, Row)   Table
//    table, string, row - c 
//    table, string, row - c 
  try
    {
     if (Office=="OO")
      {
       Variant vTables, vTable, vCell;;
       vTables = Document.OleFunction("getTextTables"); //  
       vTable = vTables.OleFunction("getByIndex", table-1);  //   
       vCell = vTable.OleFunction("getCellByPosition", row-1, string-1); //   
       vCell.OleFunction("setString", str);
      }
     if (Office=="MSO")
      {
       Variant word_rang, vTables, vTable, vCell;;
       word_rang=Document.OleFunction("Range");
       vTables=word_rang.OlePropertyGet("Tables");
       vTable=vTables.OleFunction("Item",(Variant)(table));
       vCell=vTable.OleFunction("Cell", string, row);
       vCell.OlePropertyGet("Range").OlePropertySet("Text",StringToOleStr(str));
      }
     }
  catch (Exception &E)
    {
     ShowMessage("     " + E.Message);
    }
}
//---------------------------------------------------------------------------
void OO_FillMergeCell(Variant Document,int table,int string,int row, AnsiString CellName, AnsiString str)
{
//   STR      (CellName, String, Row)   Table
//     
  try
    {
       Variant vTables, vTable, vCell;

       vTables = Document.OleFunction("getTextTables"); //  
       vTable = vTables.OleFunction("getByIndex", table-1);  //   

       //    
       int Ost = ((string)%2); //     2
       int Cel = ((string+2)/2)-1;  //      2
       AnsiString S=CellName + IntToStr(Cel)+"."+IntToStr(row)+"."+IntToStr(1+Ost);

       vCell = vTable.OleFunction("getCellByName", S); //   
       vCell.OleFunction("setString", str);
     }
  catch (Exception &E)
    {
     ShowMessage("       " + E.Message);
    }
}
//---------------------------------------------------------------------------
void OfficeTableAddRow_Alt(AnsiString Office, Variant Document, int table)
{
 //  1   
  try
    {
     Variant Tables, Table, Rows;
     if (Office=="OO")
      {
//   -        !
       Tables = Document.OleFunction("getTextTables"); //  
       Table = Tables.OleFunction("getByIndex", table-1);  //   
       Rows = Table.OleFunction("getRows");
//       Rows.OleFunction("insertByIndex", 5, 2); //  2    5-
       Rows.OleFunction("insertByIndex", Rows.OleFunction("getCount"), 1); //  1   
      }
     if (Office=="MSO")
      {
       Variant word_rang;
       word_rang=Document.OleFunction("Range");
       Tables=word_rang.OlePropertyGet("Tables");
       Table=Tables.OleFunction("Item",(Variant)table);
       Rows = Table.OlePropertyGet("Rows");
       Rows.OleProcedure("Add"); //  1   
      }
    }
  catch (Exception &E)
    {
     ShowMessage("   1    " + E.Message);
    }
}
//---------------------------------------------------------------------------
void OfficeTableAddRow(AnsiString Office, Variant Document, int table)
{
 //  1   
  try
    {
     Variant Tables, Table, Rows;
     if (Office=="OO")
      {
/*
//   -        !
       Tables = Document.OleFunction("getTextTables"); //  
       Table = Tables.OleFunction("getByIndex", table-1);  //   
       Rows = Table.OleFunction("getRows");
//       Rows.OleFunction("insertByIndex", 5, 2); //  2    5-
       Rows.OleFunction("insertByIndex", Rows.OleFunction("getCount"), 1); //  1   
*/

       // ,  OfficeTableAddRow   ,       OfficeSaveDoc(vOffice, vDoc);

       int Bounds[2] = {0,-1};
       Variant ServiceManager;
       Variant Dispatcher, Frame, CurrentController, vViewCursor;
       Variant vCell;
       Variant vEmptyParam;

       ServiceManager = Variant::CreateObject("com.sun.star.ServiceManager");
       Dispatcher = ServiceManager.OleFunction("createInstance", "com.sun.star.frame.DispatchHelper");
       CurrentController = Document.OleFunction("getCurrentController");

       Tables = Document.OleFunction("getTextTables"); //  
       Table = Tables.OleFunction("getByIndex", table-1);  //   
       Rows = Table.OleFunction("getRows");
       vCell = Table.OleFunction("getCellByPosition", 1, Rows.OleFunction("getCount")-1); //   

       vViewCursor = CurrentController.OleFunction("getViewCursor");
       vViewCursor.OleFunction("gotoRange", vCell, false);
       Frame = CurrentController.OleFunction("getFrame");

       vEmptyParam = VarArrayCreate(Bounds, 1, varVariant);
       Dispatcher.OleFunction("executeDispatch", Frame, ".uno:InsertRows", "", 0, vEmptyParam);

      //   ,  
       vEmptyParam = Unassigned;
      }
     if (Office=="MSO")
      {
       Variant word_rang;
       word_rang=Document.OleFunction("Range");
       Tables=word_rang.OlePropertyGet("Tables");
       Table=Tables.OleFunction("Item",(Variant)table);
       Rows = Table.OlePropertyGet("Rows");
       Rows.OleProcedure("Add"); //  1   
      }
    }
  catch (Exception &E)
    {
     ShowMessage("   1    " + E.Message);
    }
}
//---------------------------------------------------------------------------
Variant OfficeOpenDoc(AnsiString Office, Variant *app, AnsiString FileName)
{
//  
  try
    {
     Variant vApp, Document;
     if (Office=="OO")
      {
       Variant Desktop;
       Variant OpenParams;
       int Bounds[2] = {0,0};

       vApp = Variant::CreateObject("com.sun.star.ServiceManager");
       Desktop = vApp.OleFunction("createInstance", "com.sun.star.frame.Desktop");
       OpenParams = VarArrayCreate(Bounds, 1, varVariant);
       Variant MyStruct = vApp.OleFunction("Bridge_GetStruct","com.sun.star.beans.PropertyValue");
       MyStruct.OlePropertySet("name","Hidden");
       MyStruct.OlePropertySet("value",true);
       OpenParams.PutElement(MyStruct, 0);
       Document = Desktop.OleFunction("LoadComponentFromURL", convertToURL(FileName), "_blank", 0, OpenParams );
      }
     if (Office=="MSO")
      {
       Variant word_docs;
       vApp = Variant::CreateObject("word.application");
       word_docs = vApp.OlePropertyGet("Documents");
       Document = word_docs.OleFunction("Open" ,FileName.c_str());
      }
     *app = vApp;
     return Document;
    }
  catch (Exception &E)
    {
     ShowMessage("    " + E.Message);
     return 0;
    }
}
//---------------------------------------------------------------------------
void OfficeSaveDoc(AnsiString Office, Variant Document)
{
//  
  try
    {
     if (Office=="OO")
      {
       Document.OleFunction("store");
      }
     if (Office=="MSO")
      {
       Document.OleProcedure("Save" );
      }
    }
  catch (Exception &E)
    {
     ShowMessage("    " + E.Message);
    }
}
//---------------------------------------------------------------------------
void OfficeSaveAsDoc(AnsiString Office, Variant Document, AnsiString FileName)
{
 //  
  try
    {
     if (Office=="OO")
      {
        Variant SaveParam;
        int Bounds[2] = {0,0};
        Variant ServiceManager = Variant::CreateObject("com.sun.star.ServiceManager");
        Variant MyStruct = ServiceManager.OleFunction("Bridge_GetStruct", "com.sun.star.beans.PropertyValue");
        MyStruct.OlePropertySet("name","FilterName");
        MyStruct.OlePropertySet("value","MS Word 97");
        SaveParam = VarArrayCreate(Bounds, 1, varVariant);
        SaveParam.PutElement(MyStruct, 0);
        Document.OleFunction ("storeAsURL", convertToURL(FileName), SaveParam);
        ServiceManager = Unassigned;
      }
     if (Office=="MSO")
      {
        Document.OleProcedure("SaveAs", FileName);
      }
    }
  catch (Exception &E)
    {
     ShowMessage("     " + E.Message);
    }
}
//---------------------------------------------------------------------------
void OfficeQuit(AnsiString Office, Variant app, Variant Document)
{
 //  
 try
    {
     if (Office=="OO")
      {
        Document.OleFunction("close", true);                            // 
        Variant Desktop;                                                // 
        Desktop = app.OleFunction("createInstance", "com.sun.star.frame.Desktop");
        Desktop.OleFunction("terminate");                               //  QuickStarter
        Desktop = Unassigned;
      }
     if (Office=="MSO")
      {
        app.OleProcedure("Quit");
      }
    }
  catch (Exception &E)
    {
     ShowMessage("    " + E.Message);
    }
}
//---------------------------------------------------------------------------
WideString convertToURL(WideString FileName)
{
//      URL  
// "\\blank.doc"     !!!
    AnsiString URL = "";
    for (int i = 1; i <= FileName.Length(); i++)
    {
        char ch = (char)FileName[i];
        switch (ch)
        {
            case ' ' :
                URL += "%20";
                break;
            case '\\' :
                URL += "/";
                break;
            default :
                URL += ch;
        }
    }
    return "file://localhost/" + URL;
}
//---------------------------------------------------------------------------
void OfficeStrDel(AnsiString Office, Variant app, Variant Document, int Str, int Cnt)
//  
{
 try
    {
     if (Office=="OO")
      {
      }
     if (Office=="MSO")
      {
       //     Selection.MoveDown Unit:=wdLine, Count:=16
       //     Selection.Delete Unit:=wdCharacter, Count:=1
        Variant this_selection;
        this_selection = app.OlePropertyGet("Selection") ;
        this_selection.OleFunction("MoveDown", 5, Str);
        this_selection.OleFunction("Delete", 1, Cnt);
      }
    }
  catch (Exception &E)
    {
     ShowMessage("    " + E.Message);
    }
}
//---------------------------------------------------------------------------

